<?php

if(isset($_SERVER['REMOTE_ADDR'])) die();
include_once(dirname(__FILE__).'/../../../Application/System.php');
$System = new System();
$System->ShowPage = false;
$System->Run();
$Path = array('ip', 'dns', 'static');

$Routerboard = new Routerboard($Config['MainRouter']['HostName']);
$Routerboard->UserName = $Config['MainRouter']['UserName'];
$Routerboard->Timeout = $Config['MainRouter']['ConnectTimeout'];
$Routerboard->Debug = true;

$DbResult = $System->Database->query('SELECT * FROM `NetworkDomain`');
while($Domain = $DbResult->fetch_assoc())
{
  $DomainName = $Domain['Name'];

  // Get full domain name from parent items
  $CurrentDomain = $Domain;
  while($CurrentDomain['Parent'] > 0)
  {
    $DbResult2 = $System->Database->query('SELECT * FROM `NetworkDomain` WHERE `Id`='.$CurrentDomain['Parent']);
    $CurrentDomain = $DbResult2->fetch_assoc();
    $DomainName .= '.'.$CurrentDomain['Name'];
  }

  // Devices, Interfaces
  $Items = array();
  $DbResult2 = $System->Database->query('SELECT `NetworkInterface`.*, `NetworkDevice`.`Name` AS `DeviceName` FROM `NetworkInterface` '.
    'JOIN `NetworkDevice` ON `NetworkInterface`.`Device`=`NetworkDevice`.`Id` '.
    'WHERE `NetworkDevice`.`Used`=1');
  while($Interface = $DbResult2->fetch_assoc())
  {
    $Name = $Interface['DeviceName'];
    if($Interface['Name'] != '') $Name .= '-'.$Interface['Name'];
    $Name .= '.'.$DomainName;
    $Items[] = array('name' => $Name, 'address' => $Interface['LocalIP'], 'ttl' => '1d');
  }

  // Domain aliases
  $DbResult2 = $System->Database->query('SELECT `NetworkDomainAlias`.*, `NetworkInterface`.`LocalIP` AS `LocalIP` FROM `NetworkDomainAlias` '.
    'JOIN `NetworkDevice` ON `NetworkDomainAlias`.`Target`=`NetworkDevice`.`Name` '.
    'JOIN `NetworkInterface` ON `NetworkInterface`.`Device`=`NetworkDevice`.`Id` '.
    'WHERE `NetworkDevice`.`Used`=1');
  while($Alias = $DbResult2->fetch_assoc())
  {
    $Name = $Alias['Name'];
    $Name .= '.'.$DomainName;
    $Items[] = array('name' => $Name, 'address' => $Alias['LocalIP'], 'ttl' => $Domain['TTL']);
  }

  $DbResult2 = $System->Database->query('SELECT * FROM `NetworkDomainServer` WHERE `Domain`='.$Domain['Id']);
  if($DbResult2->num_rows > 0)
  {
    $Server = $DbResult2->fetch_assoc();
    $Routerboard->HostName = $Server['Address'];
    $Routerboard->ListUpdate($Path, array('name', 'address', 'ttl'), $Items);
  }
}